       subroutine angular_distance (az1, el1, az2, el2, ang_dist)
C compute the angular distange between two sources using the haversine formula       
C inputs:
C  az1,el1 - azimuth and elevation of position 1 in degrees
c  az2,el2 - azimuth and elevation of position 2 in degrees
      implicit none
      real az1, el1, az2, el2, ang_dist
      real*8 z, z2
      real hv
      
      z=acos(-1.d0)/180.d0
      z2=z/2.
      print*,'az1,el1,az2,el2: ',az1,el1,az2,el2
      print*,'z, z2 = ',z, z2
      
      hv = sin((el2-el1)*z2)**2+
     . cos(el1*z)*cos(el2*z)*sin((az2-az1)*z2)**2
      ang_dist = asin(sqrt(hv))/z2
      print*,'hv, ang_dist: ',hv,ang_dist
      end
      
      subroutine detector_source_offset (az, el, det, det_ang)
C compute angular distance between input direction and detector normal  
C Inputs:  
C   az, el - source direction in spacecraft coords - in degrees
C   det - detector number - 0-11 for NaIs, 12-13 for BGOs
C Output - det_ang - angle between input direction and detector normal in degrees    
      implicit none
      real az, el, det_ang
      integer det
      real det_az(0:13), det_zen(0:13)
      data det_az /45.89, 45.11, 58.44, 314.87, 303.15,  3.35, 224.93, 
     . 224.62, 236.61, 135.19, 123.73, 183.74, 0.0, 180.0/
      data det_zen /20.58, 45.31, 90.21, 45.24, 90.27, 89.79, 20.43, 
     . 46.18, 89.97, 45.55, 90.42, 90.32, 90.0, 90.0/
      print*,'Det, det_az, det_zen: ',det,det_az(det),det_zen(det)
      call angular_distance(az, el, det_az(det),90-det_zen(det),det_ang)
      end  
