      subroutine ephoton_integrator (ephot, n_ephot, matrix, nchan,
     $    n_new_ephot, new_ephot, maxen,maxchan, new_matrix)
     
C Colleen Wilson-Hodge NASA/MSFC 2009-August-24
C This code integrates over photon bins in the response matrix using the 
C trapezoidal rule.
      implicit none
C inputs
      integer maxen, maxchan, n_ephot, nchan, n_new_ephot
      real ephot(n_ephot) ! photon bin edges for matrix
      real matrix(maxen,maxchan) !input matrix
      real new_ephot(n_new_ephot) ! desired photon bin edges
C outputs      
      real new_matrix(maxen,maxchan) ! integrated matrix
C local variables 
      integer i,j, k
      real tmp_ephot(3)
c      print*,n_ephot,n_new_ephot
c      do i=1,n_ephot 
c        print*,i,ephot(i)
c      enddo	
C loop over desired photon edges
      do i=1, n_new_ephot-1
c        print*, i,new_ephot(i),ephot(i*2-1),ephot(i*2),ephot(i*2+1) 
C integrate over photon bins using 3-pt trapezoidal rule  
C note, the trapezoidal formula is actually 
C (f(a)/2+f((a+b)/2)+f(b)/2)*(b-a)/2. Here I have omitted the (b-a) term 
C because I need to divide by the photon bin width to get the matrix units right     
	do j=1,nchan 
	  new_matrix(i,j) = (matrix(i*2-1,j)/2.+matrix(i*2,j)+
     $	    matrix(i*2+1,j)/2.)/2.
	enddo
      enddo	
      end	                  
           
