      subroutine geocords(theta_geo, phi_geo, theta_source, phi_source,
     . gx, gy, gz, sl)
C Geocenter source direction cosine matrix in spacecraft coordinates.
C Inputs: 
C theta_geo, phi_geo: Geocenter zenith and azimuth angles in degrees in
C  spacecraft coordinates.     
C theta_source, phi_source: Source zenith and azimuth angles in degrees in
C  spacecraft coordinates.     
C Outputs:
C gx, gy, gz: geocenter direction cosine matrix
C sl: unit vector to source
      implicit none
      real theta_geo, phi_geo, theta_source, phi_source
      real gx(3), gy(3), gz(3), sl(3),gyr,gxr,gzr,slr
      real*4 dtr
      dtr=acos(-1.0)/180.0
      gz(1)=sin(theta_geo*dtr)*cos(phi_geo*dtr)
      gz(2)=sin(theta_geo*dtr)*sin(phi_geo*dtr)
      gz(3)=cos(theta_geo*dtr)
C normalize gz - added cawh 2008-07-28
      gzr=sqrt(gz(1)*gz(1)+gz(2)*gz(2)+gz(3)*gz(3))
      gz(1)=gz(1)/gzr
      gz(2)=gz(2)/gzr
      gz(3)=gz(3)/gzr


      sl(1)=sin(theta_source*dtr)*cos(phi_source*dtr)
      sl(2)=sin(theta_source*dtr)*sin(phi_source*dtr)
      sl(3)=cos(theta_source*dtr)
C normalize sl - added cawh 2008-07-28
      slr=sqrt(sl(1)*sl(1)+sl(2)*sl(2)+sl(3)*sl(3))
      sl(1)=sl(1)/slr
      sl(2)=sl(2)/slr
      sl(3)=sl(3)/slr


      gy(1)=gz(2)*sl(3)-gz(3)*sl(2)
      gy(2)=gz(3)*sl(1)-gz(1)*sl(3)
      gy(3)=gz(1)*sl(2)-gz(2)*sl(1)
C normalize gy - added cawh 2008-07-28
        gyr=sqrt(gy(1)*gy(1)+gy(2)*gy(2)+gy(3)*gy(3))
      
        gy(1)=gy(1)/gyr
        gy(2)=gy(2)/gyr
        gy(3)=gy(3)/gyr


      gx(1)=gy(2)*gz(3)-gy(3)*gz(2)
      gx(2)=gy(3)*gz(1)-gy(1)*gz(3)
      gx(3)=gy(1)*gz(2)-gy(2)*gz(1)
C normalize gx - added cawh 2008-07-28
        gxr=sqrt(gx(1)*gx(1)+gx(2)*gx(2)+gx(3)*gx(3))
        gx(1)=gx(1)/gxr
        gx(2)=gx(2)/gxr
        gx(3)=gx(3)/gxr


      end
