      subroutine get_atscatdb_dimensions (atscat_path, atscat_file,
     . n_ein, nlat, ntheta, nphi)
      character*80 atscat_path
      character*40 atscat_file      
      integer n_ein, n_ener, nlat, ntheta, nphi
C local variables
      character*120 atscat_fullname
      integer column, naxis, naxes(5), fpixels(6), lpixels(6)
      integer incs(5), status, readwrite, blocksize,hdutype
      integer natscat,width,datacode, felem, testlen
      logical anynull
      real*4 nulle  
      integer i, irow, nulli, unit
C Parse the full file name for the atscat database file
      testlen = len_trim(atscat_path)
      atscat_fullname = atscat_path(1:testlen)//atscat_file
C  The STATUS parameter must always be initialized.
      status=0
      nulle =0.
      nulli=0
C  Get an unused Logical Unit Number to use to open the FITS file.
      call ftgiou(unit,status)

C  Open the FITS file 
      readwrite=0
      call ftopen(unit,atscat_fullname,readwrite,blocksize,status)
c      print*,'status = ', status
C Move to the 1st extension (atscat_dbase)
      call ftmahd(unit,2,hdutype,status)
c      write(*,*) 'Moving to 1st extension, status = ',status
      column=2
      call ftgtcl(unit, column, datacode, n_ein, width,status)
      column=4
      call ftgtcl(unit, column, datacode, nlat, width,status)
      nlat=nlat-1
      column=5
      call ftgtcl(unit, column, datacode, ntheta, width,status)
      ntheta=ntheta-1
      column=6
      call ftgtcl(unit, column, datacode, nphi, width,status)
      nphi=nphi-1
C  The FITS file must always be closed before exiting the program. 
C  Any unit numbers allocated with FTGIOU must be freed with FTFIOU.
      call ftclos(unit, status)
      call ftfiou(unit, status)
C  Check for any error, and if so print out error messages.
C  The PRINTERROR subroutine is listed near the end of this file.
      if (status .gt. 0)call printerror(status)
      return
      end
