       subroutine read_atscat_alldbs(atscat_path,atscat_file,detector,
     .  at_scat_data,e_in,
     .  lat_edge,lat_cent,theta_cent, phi_cent, n_ein, n_ener, nlat, 
     .  ntheta, nphi)
C I'm going to try to modify this code so that it can read in any atscat db
C file. n_ein needs to be defined outside this routine.     
C Changes 10-22-2008
C This routine is changed to read in pre-interpolated atscat matrices.
C For these both the input and output energies have been interpolated to match
C the input (ephoton) energies for Marc's DRM database InitialGBMDRMdb001.     
C      inputs
      character*80 atscat_path
      character*40 atscat_file      
      integer n_ein, n_ener, nlat, ntheta, nphi
      integer detector
C      ouputs
      real*4 at_scat_data(n_ein,n_ein,nlat,ntheta,nphi),e_in(n_ein), 
     . lat_edge(nlat+1)
      real*4 lat_cent(nlat), theta_cent(ntheta), phi_cent(nphi)
C local variables
      character*120 atscat_fullname
      integer column, naxis, naxes(5), fpixels(6), lpixels(6)
      integer incs(5), status, readwrite, blocksize,hdutype
      integer natscat,width,datacode, felem, testlen
      logical anynull
      real*4 nulle,theta_edge(ntheta+1),phi_edge(nphi+1)  
      integer i, irow, nulli, unit
C Parse the full file name for the atscat database file
      testlen = len_trim(atscat_path)
      atscat_fullname = atscat_path(1:testlen)//atscat_file
C  The STATUS parameter must always be initialized.
      status=0
      nulle =0.
      nulli=0
C  Get an unused Logical Unit Number to use to open the FITS file.
      call ftgiou(unit,status)

C  Open the FITS file 
      readwrite=0
      call ftopen(unit,atscat_fullname,readwrite,blocksize,status)
c      print*,'status = ', status
C Move to the 1st extension (atscat_dbase)
      call ftmahd(unit,2,hdutype,status)
c      write(*,*) 'Moving to 1st extension, status = ',status
      column=1
      if (detector .le. 11) then
        irow=1
      else
        irow=2
      endif		
      felem=1
      call ftgtcl(unit, column, datacode, natscat, width,status)
c      print*,'natscat, datacode,width: ',natscat, datacode,width
      call ftgcve(unit, column, irow,felem,natscat,nulle,
     . at_scat_data,anynull,status)
c      print*,'status = ',status
c      print*,'at_scat_data(7,*,5,1,1)',
c     . (i,at_scat_data(7,i,5,1,1),i=1,64)
      column=2
c      call ftgtcl(unit, column, datacode, n_ein, width,status)
      call ftgcve(unit,column,irow,felem,n_ein,nulle,e_in,
     . anynull, status)
c      print*,'status = ',status
c      print*,'irow = ',irow
c      print*,'e_in = ',(e_in(i),i=1,n_ein)
c      column=3
c      call ftgtcl(unit,column, datacode, n_ener, width, status)
c      call ftgcve(unit,column, irow, felem, n_ener, nulle,
c     . e_out_edge, anynull, status)
      n_ener = n_ein
      column=4
c      call ftgtcl(unit, column, datacode, nlat, width,status)
c      nlat=nlat-1
      call ftgcve(unit,column,irow,felem,nlat+1,nulle,lat_edge,
     . anynull, status)
c      print*,'Status: ',status
c      print*,'lat_edge: ',(lat_edge(i),i=1,nlat+1)
      column=5
c      call ftgtcl(unit, column, datacode, ntheta, width,status)
c      ntheta=ntheta-1
      call ftgcve(unit,column,irow,felem,ntheta+1,nulle,theta_edge,
     . anynull, status)
c      print*,'Status: ',status
c      print*,'theta_edge: ',(theta_edge(i),i=1,ntheta+1)
      column=6
c      call ftgtcl(unit, column, datacode, nphi, width,status)
c      nphi=nphi-1
      call ftgcve(unit,column,irow,felem,nphi+1,nulle,phi_edge,
     . anynull, status)
c      print*,'Status: ',status
c      print*,'phi_edge: ',(phi_edge(i),i=1,nphi+1)
      do i=1,nphi
        phi_cent(i)=(phi_edge(i)+phi_edge(i+1))/2.0
      enddo
      do i=1,nlat	
        lat_cent(i)=(lat_edge(i)+lat_edge(i+1))/2.0
      enddo	
      do i=1,ntheta
	theta_cent(i)=(theta_edge(i)+theta_edge(i+1))/2.0
      enddo
       	 
C  The FITS file must always be closed before exiting the program. 
C  Any unit numbers allocated with FTGIOU must be freed with FTFIOU.
      call ftclos(unit, status)
      call ftfiou(unit, status)
C  Check for any error, and if so print out error messages.
C  The PRINTERROR subroutine is listed near the end of this file.
      if (status .gt. 0)call printerror(status)
      return
      end
      
